#include <errno.h>
#include <stdio.h>

#include "dio40_dsl.h"

int dio40_dsl_reg_read(int fd, u32 reg, u32* value)
{
	gsc_reg_t	parm;
	int			status;

	parm.reg	= reg;
	parm.value	= (u32) 0xDEADBEEF;
	parm.mask	= 0;	// ignored for reads
	status		= ioctl(fd,
						DIO40_IOCTL_REG_READ,
						(unsigned long) &parm);

	if (value)
		value[0]	= parm.value;

	if (status == -1)
		printf("ioctl() failure, errno = %d\n", errno);

	return(status);
}
