// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO40/legacy/DIO40_Linux_1.00.0_GSC_DN/dout/dio.c $
// $Rev: 32587 $
// $Date:$

#include <stdio.h>
#include <string.h>
#include <sys/time.h>

#include "main.h"



/******************************************************************************
*
*	Function:	_port_a_out
*
*	Purpose:
*
*		Output a one on the given port and make the others an input.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*		index	The index of the port signal to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _port_a_out(int fd, int index)
{
	u8	bit		= 1 << index;
	int	errs	= 0;
	int	i;

	errs	+= dio40_reg_write(fd, DIO40_GSC_CCAR, bit);
	errs	+= dio40_reg_write(fd, DIO40_GSC_COAR, bit);

	for (i = 7; i >= 0; i--)
	{
		if (i == index)
			printf("1");
		else
			printf("-");
	}

	errs	= errs ? 1 : 0;
	return(errs);
}



/******************************************************************************
*
*	Function:	_port_b_out
*
*	Purpose:
*
*		Output a one on the given port and make the others an input.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*		index	The index of the port signal to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _port_b_out(int fd, int index)
{
	u32	bit		= 1 << index;
	int	errs	= 0;
	int	i;

	errs	+= dio40_reg_write(fd, DIO40_GSC_CCBR, bit);
	errs	+= dio40_reg_write(fd, DIO40_GSC_COBR, bit);

	for (i = 31; i >= 0; i--)
	{
		if (i == index)
			printf("1");
		else
			printf("-");
	}

	errs	= errs ? 1 : 0;
	return(errs);
}



/******************************************************************************
*
*	Function:	dout_test
*
*	Purpose:
*
*		Perform a simple walking 1 Digital Output test.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

int dout_test(int fd)
{
	int	errs	= 0;
	int	i;

	label("Digital Output");
	printf("\n");

	errs	+= dio40_reset(fd);
	printf("  Port A    Port B\n");
	printf("  7------0  31-----------------------------0\n");
	printf("  ========  ================================\n");

	for (i = 0; i < 32; i++)
	{
		printf("  ");
		errs	+= _port_a_out(fd, i % 8);
		printf("  ");
		errs	+= _port_b_out(fd, i);
		printf("\n");
		usleep(100000);
	}

	errs	+= dio40_reset(fd);
	errs	= errs ? 1 : 0;
	label_level_inc();
	label("Results");
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	label_level_dec();
	return(errs);
}



