// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO40/legacy/DIO40_Linux_1.00.0_GSC_DN/led/led.c $
// $Rev: 32587 $
// $Date:$

#include <stdio.h>
#include <string.h>
#include <sys/time.h>

#include "main.h"


/******************************************************************************
*
*	Function:	_blink_test
*
*	Purpose:
*
*		Make all of the LEDs blink on and off a few times.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _blink_test(int fd)
{
	int	errs	= 0;
	int	i;

	label("Blink");

	for (i = 1; i <= 8; i++)
	{
		if (i % 2)
			errs	+= dio40_led_set(fd, 0xFF);
		else
			errs	+= dio40_led_set(fd, 0);

		sleep(1);
	}

	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}



/******************************************************************************
*
*	Function:	_walk_test
*
*	Purpose:
*
*		Perform a slow walking one and zero test.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _walk_test(int fd)
{
	u8	bit;
	int	errs	= 0;

	label("Walk");

	// Walking one.

	for (bit = 1; bit; bit *= 2)
	{
		errs	+= dio40_led_set(fd, bit);
		sleep(1);
	}

	// Walking zero.
	errs	+= dio40_led_set(fd, 0xFF);
	sleep(1);

	for (bit = 1; bit; bit *= 2)
	{
		errs	+= dio40_led_set(fd, ~bit);
		sleep(1);
	}

	errs	+= dio40_led_set(fd, 0xFF);
	sleep(1);
	errs	= errs ? 1 : 0;
	printf("%s\n", errs ? "FAIL <---" : "PASS");
	return(errs);
}


/******************************************************************************
*
*	Function:	led_test
*
*	Purpose:
*
*		Perform an LED test.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

int led_test(int fd)
{
	int	errs	= 0;

	label("LED Test");
	printf("\n");
	label_level_inc();

	errs	+= _blink_test(fd);
	errs	+= _walk_test(fd);

	label_level_dec();
	return(errs);
}




