// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/utils/gsc_util_open.c $
// $Rev: 35267 $
// $Date: 2016-06-16 16:12:23 -0500 (Thu, 16 Jun 2016) $

#include <fcntl.h>
#include <stdio.h>

#include "gsc_utils.h"



/******************************************************************************
*
*	Function:	gsc_dev_open
*
*	Purpose:
*
*		Perform an open on the device with the specified index.
*
*	Arguments:
*
*		index	The index of the board to accessed.
*
*		base	The base name for the /proc file entry.
*
*		share	Open the device for shared access?
*
*	Returned:
*
*		>= 0	The handle to the board to access.
*		-1		There was a problem. Consult errno.
*
******************************************************************************/

int gsc_dev_open(int index, const char* base, int share)
{
	char		buf[80];
	int			fd;
	const char*	psz	= share ? "Shared" : "Exclusive";;

	sprintf(buf, "Opening #%d", index);
	gsc_label(buf);
	fd	= os_open(index, base, share);

	if (fd == -1)
		printf("FAIL <---  (%s)\n", psz);
	else
		printf("PASS  (%s)\n", psz);

	return(fd);
}


