// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/utils/linux/os_util_open.c $
// $Rev: 35269 $
// $Date: 2016-06-16 16:14:08 -0500 (Thu, 16 Jun 2016) $

#include <fcntl.h>
#include <stdio.h>

#include "gsc_utils.h"



/******************************************************************************
*
*	Function:	os_open
*
*	Purpose:
*
*		Perform an open on the device with the specified index.
*
*	Arguments:
*
*		index	The index of the board to accessed.
*
*		base	The base name for the /proc file entry.
*
*		share	Open the device for shared access?
*
*	Returned:
*
*		>= 0	The handle to the board to access.
*		-1		There was a problem. Consult errno.
*
******************************************************************************/

int os_open(int index, const char* base, int share)
{
	int		fd;
	int		flags;
	char	name[128];

	sprintf(name, "/dev/%s.%d", base, index);
	flags	= O_RDWR | (share ? O_APPEND : 0);
	fd		= open(name, flags);
	return(fd);
}


